#!/bin/sh
. /usr/lib/ci-tests/sysklogd/sysklogd_add_functions.sh

TESTBIN=$1
TESTCASE=$2
TESTCOUNT=8

USAGE="Usage: /usr/bin/syslog_tst.sh /usr/bin/syslog_tst testcasename"

# Function to run test programm ($*) and get block data from syslogd
run_test_case() 
{
	write_string "START"
	assert_cmd $*
	write_string "STOP"
	assert_cmd get_block_data_from_syslog 
}

# Test case 1
write_test_string_in_syslog()
{
	teststr="This is a test for sysklogd"
	run_test_case "$TESTBIN $teststr"

	resultstr=`grep "DOTEST" $TMP_BLOCK_DATA | sed  "s/^[A-Za-z]*.*]:.//"`
	resultstr=`echo $resultstr`
	echo "$TEST_NAME: Showing result string from syslog: $resultstr"

	assert_str "$resultstr" "=" "$teststr" "Test string and string from syslog differ"
	echo "$TEST_NAME: Test string and string from syslog the same. OK"
}

#Test case 2
write_all_level_strings_in_syslog()
{
	echo "$TEST_NAME: Writing test string in syslog"
	echo "$TEST_NAME: Starting test"

	run_test_case "$TESTBIN"

	countstr=`grep "DOTEST" $TMP_BLOCK_DATA | awk 'END {print NR}'`
	echo "$TEST_NAME: $TESTBIN wrote in /var/log/syslog $countstr srings"

	assert_condition  "$countstr -eq $TESTCOUNT" "Written test string count and read test string count from syslog differ"	
	echo "$TEST_NAME: $TESTBIN wrote expected string count"
}

# Main 
if [ $# -ne 2  ] ; then
	echo $USAGE
	exit 1
fi

if [ ! `pidof syslogd` ] ; then
	echo "$TEST_NAME: Starting syslogd before any action"
	$which_syslogd
	delay $SECOND
fi

#execute test case

SYSTEM="syslogd"
TEST_NAME=$TESTCASE
print_test_header 
assert_cmd $TESTCASE
print_test_results 0

#End

